Grid allows you to load large amount of data without performance degradation.
To use virtualization, you need to inject VirtualScroll
module in grid.
Row virtualization allows you to load and render rows only in the content viewport. It is an alternative way of paging in which the data will be loaded while scrolling vertically. To setup the row virtualization, you need to define
enableVirtualization
as true and content height by height
property.
The number of records displayed in the Grid is determined implicitly by height of the content area. Also, you have an option to define a visible number of records by
the pageSettings.pageSize
property. The loaded data will be cached and reused when it is needed for next time.
var names = ['TOM', 'Hawk', 'Jon', 'Chandler', 'Monica', 'Rachel', 'Phoebe', 'Gunther', 'Ross', 'Geller', 'Joey', 'Bing', 'Tribbiani', 'Janice', 'Bong', 'Perk', 'Green', 'Ken', 'Adams'];
var hours = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
var designation = ['Manager', 'Engineer 1', 'Engineer 2', 'Developer', 'Tester'];
var statusValue = ['Completed', 'Open', 'In Progress', 'Review', 'Testing']
var data = function(count) {
var result = [];
for (var i = 0; i < count; i++) {
result.push({
TaskID: i + 1,
Engineer: names[Math.round(Math.random() * names.length)] || names[0],
Designation: designation[Math.round(Math.random() * designation.length)] || designation[0],
Estimation: hours[Math.round(Math.random() * hours.length)] || hours[0],
Status: statusValue[Math.round(Math.random() * statusValue.length)] || statusValue[0]
});
}
return result;
};
(window).getStatus = function(statusValue){
var colors = { 'Completed': 'green', 'Open': 'red', 'In Progress': '#FB1E77', 'Review': 'brown', 'Testing': '#1EC1FB' };
return '<span style="color:' + colors[statusValue] + '">' + statusValue + '</span>';
};
ej.grids.Grid.Inject(ej.grids.VirtualScroll, ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
dataSource: data(1000),
height: 300,
enableVirtualization: true,
pageSettings: { pageSize: 50 },
editSettings: { allowAdding: true, allowEditing: true, allowDeleting: true, mode: 'Normal' },
toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
columns: [
{ field: 'TaskID', headerText: 'Task ID', textAlign: 'Right', width: 100, type: 'number', isPrimaryKey: true, validationRules: { required: true } },
{ field: 'Engineer', width: 100 },
{ field: 'Designation', width: 140, editType: 'dropdownedit', validationRules: { required: true } },
{ field: 'Estimation', textAlign: 'Right', width: 110, editType: 'numericedit', validationRules: { required: true } },
{ field: 'Status', width: 140, template: '${getStatus(data.Status)}', editType: 'dropdownedit' }
]
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
<title>EJ2 Grid</title>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description" content="Typescript Grid Control">
<meta name="author" content="Syncfusion">
<link href="index.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-base/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-grids/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-buttons/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-popups/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-navigations/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-dropdowns/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-lists/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-inputs/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-calendars/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-splitbuttons/styles/material.css" rel="stylesheet">
<style>
.e-row[aria-selected="true"] .e-customizedExpandcell {
background-color: #e0e0e0;
}
.e-grid.e-gridhover tr[role='row']:hover {
background-color: #eee;
}
.e-expand::before {
content: '\e5b8';
}
</style>
<script src="https://cdn.syncfusion.com/ej2/20.1.58/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
<script id="template" type="text/x-template">
<input id='${OrderID}' value='${Freight}' class='custemp' type='text' style='width: 100%'>
</script>
<div id="container">
<button id="show">Selected Records</button>
<div id="Grid"></div>
</div>
<script>
var ele = document.getElementById('container');
if(ele) {
ele.style.visibility = "visible";
}
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>
Column virtualization allows you to virtualize columns. It will render columns which are in the viewport. You can scroll horizontally to view more columns.
To setup the column virtualization, set the
enableVirtualization
and
enableColumnVirtualization
properties as true
.
var virtualData = [];
var names = ['hardire', 'abramjo01', 'aubucch01', 'Hook', 'Rumpelstiltskin', 'Belle', 'Emma', 'Regina', 'Aurora', 'Elsa', 'Anna', 'Snow White', 'Prince Charming', 'Cora', 'Zelena', 'August', 'Mulan', 'Graham', 'Discord', 'Will', 'Robin Hood', 'Jiminy Cricket', 'Henry', 'Neal', 'Red', 'Aaran', 'Aaren', 'Aarez', 'Aarman', 'Aaron', 'Aaron-James', 'Aarron', 'Aaryan', 'Aaryn', 'Aayan', 'Aazaan', 'Abaan', 'Abbas', 'Abdallah', 'Abdalroof', 'Abdihakim', 'Abdirahman', 'Abdisalam', 'Abdul', 'Abdul-Aziz', 'Abdulbasir', 'Abdulkadir', 'Abdulkarem', 'Abdulkhader', 'Abdullah', 'Abdul-Majeed', 'Abdulmalik', 'Abdul-Rehman', 'Abdur', 'Abdurraheem', 'Abdur-Rahman', 'Abdur-Rehmaan', 'Abel', 'Abhinav', 'Abhisumant', 'Abid', 'Abir', 'Abraham', 'Abu', 'Abubakar', 'Ace', 'Adain', 'Adam', 'Adam-James', 'Addison', 'Addisson', 'Adegbola', 'Adegbolahan', 'Aden', 'Adenn', 'Adie', 'Adil', 'Aditya', 'Adnan', 'Adrian', 'Adrien', 'Aedan', 'Aedin', 'Aedyn', 'Aeron', 'Afonso', 'Ahmad', 'Ahmed', 'Ahmed-Aziz', 'Ahoua', 'Ahtasham', 'Aiadan', 'Aidan', 'Aiden', 'Aiden-Jack', 'Aiden-Vee'];
function dataSource(){
for (var i = 0; i < 1000; i++) {
virtualData.push({
'SNo': i + 1,
'FIELD1': names[Math.floor(Math.random() * names.length)],
'FIELD2': 1967 + (i % 10), 'FIELD3': Math.floor(Math.random() * 200),
'FIELD4': Math.floor(Math.random() * 100), 'FIELD5': Math.floor(Math.random() * 2000), 'FIELD6': Math.floor(Math.random() * 1000), 'FIELD7': Math.floor(Math.random() * 100), 'FIELD8': Math.floor(Math.random() * 10), 'FIELD9': Math.floor(Math.random() * 10), 'FIELD10': Math.floor(Math.random() * 100), 'FIELD11': Math.floor(Math.random() * 100), 'FIELD12': Math.floor(Math.random() * 1000), 'FIELD13': Math.floor(Math.random() * 10), 'FIELD14': Math.floor(Math.random() * 10), 'FIELD15': Math.floor(Math.random() * 1000), 'FIELD16': Math.floor(Math.random() * 200), 'FIELD17': Math.floor(Math.random() * 300), 'FIELD18': Math.floor(Math.random() * 400), 'FIELD19': Math.floor(Math.random() * 500), 'FIELD20': Math.floor(Math.random() * 700), 'FIELD21': Math.floor(Math.random() * 800), 'FIELD22': Math.floor(Math.random() * 1000), 'FIELD23': Math.floor(Math.random() * 2000), 'FIELD24': Math.floor(Math.random() * 150), 'FIELD25': Math.floor(Math.random() * 1000), 'FIELD26': Math.floor(Math.random() * 100), 'FIELD27': Math.floor(Math.random() * 400), 'FIELD28': Math.floor(Math.random() * 600), 'FIELD29': Math.floor(Math.random() * 500), 'FIELD30': Math.floor(Math.random() * 300),
});
}
}
dataSource();
ej.grids.Grid.Inject(ej.grids.VirtualScroll, ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
dataSource: virtualData,
enableVirtualization: true,
enableColumnVirtualization: true,
height: 300,
editSettings: { allowAdding: true, allowEditing: true, allowDeleting: true, mode: 'Normal' },
toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
columns: [
{ field: 'SNo', headerText: 'S.No', width: 120, isPrimaryKey: true, validationRules: { required: true } },
{ field: 'FIELD1', headerText: 'Player Name', width: 140, editType: 'dropdownedit', validationRules: { required: true } },
{ field: 'FIELD2', headerText: 'Year', width: 120, textAlign: 'Right' },
{ field: 'FIELD3', headerText: 'Stint', width: 120, textAlign: 'Right' },
{ field: 'FIELD4', headerText: 'TMID', width: 120, textAlign: 'Right' },
{ field: 'FIELD5', headerText: 'LGID', width: 120, textAlign: 'Right' },
{ field: 'FIELD6', headerText: 'GP', width: 120, textAlign: 'Right' },
{ field: 'FIELD7', headerText: 'GS', width: 120, textAlign: 'Right' },
{ field: 'FIELD8', headerText: 'Minutes', width: 120, textAlign: 'Right' },
{ field: 'FIELD9', headerText: 'Points', width: 120, textAlign: 'Right' },
{ field: 'FIELD10', headerText: 'oRebounds', width: 130, textAlign: 'Right' },
{ field: 'FIELD11', headerText: 'dRebounds', width: 130, textAlign: 'Right' },
{ field: 'FIELD12', headerText: 'Rebounds', width: 120, textAlign: 'Right' },
{ field: 'FIELD13', headerText: 'Assists', width: 120, textAlign: 'Right' },
{ field: 'FIELD14', headerText: 'Steals', width: 120, textAlign: 'Right' },
{ field: 'FIELD15', headerText: 'Blocks', width: 120, textAlign: 'Right' },
{ field: 'FIELD16', headerText: 'Turnovers', width: 130, textAlign: 'Right' },
{ field: 'FIELD17', headerText: 'PF', width: 130, textAlign: 'Right' },
{ field: 'FIELD18', headerText: 'fgAttempted', width: 150, textAlign: 'Right' },
{ field: 'FIELD19', headerText: 'fgMade', width: 120, textAlign: 'Right' },
{ field: 'FIELD20', headerText: 'ftAttempted', width: 150, textAlign: 'Right' },
{ field: 'FIELD21', headerText: 'ftMade', width: 120, textAlign: 'Right' },
{ field: 'FIELD22', headerText: 'ThreeAttempted', width: 150, textAlign: 'Right' },
{ field: 'FIELD23', headerText: 'ThreeMade', width: 130, textAlign: 'Right' },
{ field: 'FIELD24', headerText: 'PostGP', width: 120, textAlign: 'Right' },
{ field: 'FIELD25', headerText: 'PostGS', width: 120, textAlign: 'Right' },
{ field: 'FIELD26', headerText: 'PostMinutes', width: 120, textAlign: 'Right' },
{ field: 'FIELD27', headerText: 'PostPoints', width: 130, textAlign: 'Right' },
{ field: 'FIELD28', headerText: 'PostoRebounds', width: 130, textAlign: 'Right' },
{ field: 'FIELD29', headerText: 'PostdRebounds', width: 130, textAlign: 'Right' },
{ field: 'FIELD30', headerText: 'PostRebounds', width: 130, textAlign: 'Right', editType: 'numericedit', validationRules: { required: true } }]
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
<title>EJ2 Grid</title>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description" content="Typescript Grid Control">
<meta name="author" content="Syncfusion">
<link href="index.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-base/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-grids/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-buttons/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-popups/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-navigations/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-dropdowns/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-lists/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-inputs/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-calendars/styles/material.css" rel="stylesheet">
<link href="//cdn.syncfusion.com/ej2/20.1.58/ej2-splitbuttons/styles/material.css" rel="stylesheet">
<style>
.e-row[aria-selected="true"] .e-customizedExpandcell {
background-color: #e0e0e0;
}
.e-grid.e-gridhover tr[role='row']:hover {
background-color: #eee;
}
.e-expand::before {
content: '\e5b8';
}
</style>
<script src="https://cdn.syncfusion.com/ej2/20.1.58/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
<script id="template" type="text/x-template">
<input id='${OrderID}' value='${Freight}' class='custemp' type='text' style='width: 100%'>
</script>
<div id="container">
<button id="show">Selected Records</button>
<div id="Grid"></div>
</div>
<script>
var ele = document.getElementById('container');
if(ele) {
ele.style.visibility = "visible";
}
</script>
<script src="index.js" type="text/javascript"></script>
</body></html>
Column’s
width
is required for column virtualization. If column’s width is not defined then Grid will consider its value as200px
.
Both the row and column virtualization can be used along with grouping. At initial rendering, the virtual height of scrollbar will be set based on the total number of records and after grouping, it will be refreshed based on the grouped state(expand/collapse). While collapse the group caption row in current viewport then the next view page grouped records are shown.
The collapsed/expanded state will persist only for local dataSource while scrolling.
Group with Page
topic..e-grid .e-row {
height: 2em;
}
selectRows
method is not supported in virtual scrolling.

Grid allows you to load large amount of data without performance degradation.
To use virtualization, you need to inject VirtualScroll
module in the provide
section.
Row virtualization allows you to load and render rows only in content viewport. It is an alternative way of
paging in which the data will load while scrolling vertically.
To setup the row virtualization, you need to define
enableVirtualization
as true and
content height by height
property.
The number of records displayed in the Grid is determined implicitly by height of content area. Also you have an option to define visible
number of records by
pageSettings.pageSize
property.
The loaded data will be cached and reused when it is needed for next time.
<template>
<div id="app">
<ejs-grid :dataSource='data' height=300 :enableVirtualization=true :pageSettings='options'>
<e-columns>
<e-column field='TaskID' headerText='Task ID' textAlign='Right' width=70></e-column>
<e-column field='Engineer' width=100></e-column>
<e-column field='Designation' width=100></e-column>
<e-column field='Estimation' textAlign='Right' width=100></e-column>
<e-column field='Status' width=100></e-column>
</e-columns>
</ejs-grid>
</div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, VirtualScroll } from "@syncfusion/ej2-vue-grids";
Vue.use(GridPlugin);
let names = ['TOM', 'Hawk', 'Jon', 'Chandler', 'Monica', 'Rachel', 'Phoebe', 'Gunther', 'Ross', 'Geller', 'Joey', 'Bing', 'Tribbiani', 'Janice', 'Bong', 'Perk', 'Green', 'Ken', 'Adams'];
let hours = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
let designation = ['Manager', 'Engineer 1', 'Engineer 2', 'Developer', 'Tester'];
let status = ['Completed', 'Open', 'In Progress', 'Review', 'Testing']
let data = (count) => {
let result = [];
for (let i = 0; i < count; i++) {
result.push({
TaskID: i + 1,
Engineer: names[Math.round(Math.random() * names.length)] || names[0],
Designation: designation[Math.round(Math.random() * designation.length)] || designation[0],
Estimation: hours[Math.round(Math.random() * hours.length)] || hours[0],
Status: status[Math.round(Math.random() * status.length)] || status[0]
});
}
return result;
};
export default {
data() {
return {
data: data(1000),
options: { pageSize: 50 }
};
},
provide: {
grid: [VirtualScroll]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>
Column virtualization allows you to virtualize columns. It will render columns which are in viewport. You can scroll horizontally to view more columns.
To setup the column virtualization, set the
enableVirtualization
and
enableColumnVirtualization
properties as true
.
<template>
<div id="app">
<ejs-grid :dataSource='data' height=300 :enableVirtualization=true :enableColumnVirtualization=true :pageSettings='options'>
<e-columns>
<e-column field='FIELD1' headerText='Player Name' width=140></e-column>
<e-column field='FIELD2' headerText='Year' width=120 textAlign='Right'></e-column>
<e-column field='FIELD3' headerText='Stint' width=120 textAlign='Right'></e-column>
<e-column field='FIELD4' headerText='TMID' width=120 textAlign='Right'></e-column>
<e-column field='FIELD5' headerText='LGID' width=120 textAlign='Right'></e-column>
<e-column field='FIELD6' headerText='GP' width=120 textAlign='Right'></e-column>
<e-column field='FIELD7' headerText='GS' width=120 textAlign='Right'></e-column>
<e-column field='FIELD8' headerText='Minutes' width=120 textAlign='Right'></e-column>
<e-column field='FIELD9' headerText='Points' width=120 textAlign='Right'></e-column>
<e-column field='FIELD10' headerText='oRebounds' width=130 textAlign='Right'></e-column>
<e-column field='FIELD11' headerText='dRebounds' width=130 textAlign='Right'></e-column>
<e-column field='FIELD12' headerText='Rebounds' width=120 textAlign='Right'></e-column>
<e-column field='FIELD13' headerText='Assists' width=120 textAlign='Right'></e-column>
<e-column field='FIELD14' headerText='Steals' width=120 textAlign='Right'></e-column>
<e-column field='FIELD15' headerText='Blocks' width=120 textAlign='Right'></e-column>
<e-column field='FIELD16' headerText='Turnovers' width=130 textAlign='Right'></e-column>
<e-column field='FIELD17' headerText='PF' width=130 textAlign='Right'></e-column>
<e-column field='FIELD18' headerText='fgAttempted' width=150 textAlign='Right'></e-column>
<e-column field='FIELD19' headerText='fgMade' width=120 textAlign='Right'></e-column>
<e-column field='FIELD20' headerText='ftAttempted' width=150 textAlign='Right'></e-column>
<e-column field='FIELD21' headerText='ftMade' width=120 textAlign='Right'></e-column>
<e-column field='FIELD22' headerText='ThreeAttempted' width=150 textAlign='Right'></e-column>
<e-column field='FIELD23' headerText='ThreeMade' width=130 textAlign='Right'></e-column>
<e-column field='FIELD24' headerText='PostGP' width=120 textAlign='Right'></e-column>
<e-column field='FIELD25' headerText='PostGS' width=120 textAlign='Right'></e-column>
<e-column field='FIELD26' headerText='PostMinutes' width=120 textAlign='Right'></e-column>
<e-column field='FIELD27' headerText='PostPoints' width=130 textAlign='Right'></e-column>
<e-column field='FIELD28' headerText='PostoRebounds' width=130 textAlign='Right'></e-column>
<e-column field='FIELD29' headerText='PostdRebounds' width=130 textAlign='Right'></e-column>
<e-column field='FIELD30' headerText='PostRebounds' width=130 textAlign='Right'></e-column>
</e-columns>
</ejs-grid>
</div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, VirtualScroll } from "@syncfusion/ej2-vue-grids";
Vue.use(GridPlugin);
let virtualData = [];
let names: string[] = ['hardire', 'abramjo01', 'aubucch01', 'Hook', 'Rumpelstiltskin', 'Belle', 'Emma', 'Regina', 'Aurora', 'Elsa', 'Anna', 'Snow White', 'Prince Charming', 'Cora', 'Zelena', 'August', 'Mulan', 'Graham', 'Discord', 'Will', 'Robin Hood', 'Jiminy Cricket', 'Henry', 'Neal', 'Red', 'Aaran', 'Aaren', 'Aarez', 'Aarman', 'Aaron', 'Aaron-James', 'Aarron', 'Aaryan', 'Aaryn', 'Aayan', 'Aazaan', 'Abaan', 'Abbas', 'Abdallah', 'Abdalroof', 'Abdihakim', 'Abdirahman', 'Abdisalam', 'Abdul', 'Abdul-Aziz', 'Abdulbasir', 'Abdulkadir', 'Abdulkarem', 'Abdulkhader', 'Abdullah', 'Abdul-Majeed', 'Abdulmalik', 'Abdul-Rehman', 'Abdur', 'Abdurraheem', 'Abdur-Rahman', 'Abdur-Rehmaan', 'Abel', 'Abhinav', 'Abhisumant', 'Abid', 'Abir', 'Abraham', 'Abu', 'Abubakar', 'Ace', 'Adain', 'Adam', 'Adam-James', 'Addison', 'Addisson', 'Adegbola', 'Adegbolahan', 'Aden', 'Adenn', 'Adie', 'Adil', 'Aditya', 'Adnan', 'Adrian', 'Adrien', 'Aedan', 'Aedin', 'Aedyn', 'Aeron', 'Afonso', 'Ahmad', 'Ahmed', 'Ahmed-Aziz', 'Ahoua', 'Ahtasham', 'Aiadan', 'Aidan', 'Aiden', 'Aiden-Jack', 'Aiden-Vee'];
function dataSource() {
for (let i = 0; i < 1000; i++) {
virtualData.push({ 'FIELD1': names[Math.floor(Math.random() * names.length)],
'FIELD2': 1967 + (i % 10), 'FIELD3': Math.floor(Math.random() * 200),
'FIELD4': Math.floor(Math.random() * 100), 'FIELD5': Math.floor(Math.random() * 2000), 'FIELD6': Math.floor(Math.random() * 1000), 'FIELD7': Math.floor(Math.random() * 100), 'FIELD8': Math.floor(Math.random() * 10), 'FIELD9': Math.floor(Math.random() * 10), 'FIELD10': Math.floor(Math.random() * 100), 'FIELD11': Math.floor(Math.random() * 100), 'FIELD12': Math.floor(Math.random() * 1000), 'FIELD13': Math.floor(Math.random() * 10), 'FIELD14': Math.floor(Math.random() * 10), 'FIELD15': Math.floor(Math.random() * 1000), 'FIELD16': Math.floor(Math.random() * 200), 'FIELD17': Math.floor(Math.random() * 300), 'FIELD18': Math.floor(Math.random() * 400), 'FIELD19': Math.floor(Math.random() * 500), 'FIELD20': Math.floor(Math.random() * 700), 'FIELD21': Math.floor(Math.random() * 800), 'FIELD22': Math.floor(Math.random() * 1000), 'FIELD23': Math.floor(Math.random() * 2000), 'FIELD24': Math.floor(Math.random() * 150), 'FIELD25': Math.floor(Math.random() * 1000), 'FIELD26': Math.floor(Math.random() * 100), 'FIELD27': Math.floor(Math.random() * 400), 'FIELD28': Math.floor(Math.random() * 600), 'FIELD29': Math.floor(Math.random() * 500), 'FIELD30': Math.floor(Math.random() * 300), });
}
}
dataSource();
export default {
data() {
return {
data: virtualData,
options: { pageSize: 50 }
};
},
provide: {
grid: [VirtualScroll]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>
Column’s
width
is required for column virtualization. If column’s width is not defined then Grid will consider its value as200px
.
Both the row and column virtualization can be used along with grouping. At initial rendering, the virtual height of scrollbar will be set based on the total number of records and after grouping, it will be refreshed based on the grouped state(expand/collapse). While collapse the group caption row in current viewport then the next view page grouped records are shown.
The collapsed/expanded state will persist only for local dataSource while scrolling.
Group with Page
topic.rowHeight
as below to ensure all the table rows are in same height.<ejs-grid :dataSource='data' rowHeight=50>
</ejs-grid>
selectRows
method is not supported in virtual scrolling.

Grid allows you to load large amount of data without performance degradation.
To use virtualization, you need to inject VirtualScroll module in grid.
Row virtualization allows you to load and render rows only in content viewport.
It is an alternative way of paging in which the data will load while scrolling vertically.
To setup the row virtualization, you need to define
enableVirtualization
as true and
content height by height
property.
The number of records displayed in the Grid is determined implicitly by height of content area. Also you have an option to define visible number of records by pageSettings.pageSize
property.
The loaded data will be cached and reused when it is needed for next time.
import { ColumnDirective, ColumnsDirective, GridComponent, Inject } from '@syncfusion/ej2-react-grids';
import { PageSettingsModel, VirtualScroll} from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './largeData';
export default class App extends React.Component<{}, {}>{
public data: object[] = data(1000);
public pageSettings: PageSettingsModel = { pageSize: 50 };
public render() {
return <GridComponent dataSource={this.data} height={300} enableVirtualization={true}
pageSettings={ this.pageSettings }>
<Inject services={[VirtualScroll]} />
<ColumnsDirective>
<ColumnDirective field='TaskID' headerText='Task ID' width='70' textAlign='Right'/>
<ColumnDirective field='Engineer' width='100'/>
<ColumnDirective field='Designation' width='100'/>
<ColumnDirective field='Estimation' headerText='Estimation' textAlign='Right' width='100'/>
<ColumnDirective field='Status' width='100'/>
</ColumnsDirective>
</GridComponent>
}
}
const names = ['TOM', 'Hawk', 'Jon', 'Chandler', 'Monica', 'Rachel', 'Phoebe', 'Gunther', 'Ross',
'Geller', 'Joey', 'Bing', 'Tribbiani', 'Janice', 'Bong', 'Perk', 'Green',
'Ken', 'Adams'];
const hours = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
const designation = ['Manager', 'Engineer 1', 'Engineer 2', 'Developer', 'Tester'];
const status = ['Completed', 'Open', 'In Progress', 'Review', 'Testing']
export function data(count: number) {
const result = [];
for (let i = 0; i < count; i++) {
result.push({
Designation: designation[Math.round(Math.random() * designation.length)] || designation[0],
Engineer: names[Math.round(Math.random() * names.length)] || names[0],
Estimation: hours[Math.round(Math.random() * hours.length)] || hours[0],
Status: status[Math.round(Math.random() * status.length)] || status[0],
TaskID: i + 1
});
}
return result;
};
Column virtualization allows you to virtualize columns. It will render columns which are in viewport. You can scroll horizontally to view more columns.
To setup the column virtualization, set the enableVirtualization
and enableColumnVirtualization
properties as true.
import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';
import { Inject, VirtualScroll} from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { dataSource } from './virtualData';
export default class App extends React.Component<{}, {}>{
public data: object[] = dataSource();
public render() {
return <GridComponent dataSource={this.data} height={300} enableVirtualization={true}
enableColumnVirtualization={true} pageSettings={{ pageSize: 50 }}>
<Inject services={[VirtualScroll]} />
<ColumnsDirective>
<ColumnDirective field='FIELD1' headerText='Player Name' width='140'/>
<ColumnDirective field='FIELD2' headerText='Year' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD3' headerText='Stint' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD4' headerText='TMID' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD5' headerText='LGID' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD6' headerText='GP' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD7' headerText='GS' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD8' headerText='Minutes' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD9' headerText='Points' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD10' headerText='oRebounds' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD11' headerText='dRebounds' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD12' headerText='Rebounds' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD13' headerText='Assists' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD14' headerText='Steals' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD15' headerText='Blocks' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD16' headerText='Turnovers' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD17' headerText='PF' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD18' headerText='fgAttempted' width='150' textAlign='Right'/>
<ColumnDirective field='FIELD19' headerText='fgMade' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD20' headerText='ftAttempted' width='150' textAlign='Right'/>
<ColumnDirective field='FIELD21' headerText='ftMade' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD22' headerText='ThreeAttempted' width='150' textAlign='Right'/>
<ColumnDirective field='FIELD23' headerText='ThreeMade' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD24' headerText='PostGP' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD25' headerText='PostGS' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD26' headerText='PostMinutes' width='120' textAlign='Right'/>
<ColumnDirective field='FIELD27' headerText='PostPoints' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD28' headerText='PostoRebounds' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD29' headerText='PostdRebounds' width='130' textAlign='Right'/>
<ColumnDirective field='FIELD30' headerText='PostRebounds' width='130' textAlign='Right'/>
</ColumnsDirective>
</GridComponent>
}
};
Column’s
width
is required for column virtualization. If column’s width is not defined then Grid will consider its value as 200px.
Both the row and column virtualization can be used along with grouping. At initial rendering, the virtual height of scrollbar will be set based on the total number of records and after grouping, it will be refreshed based on the grouped state(expand/collapse). While collapse the group caption row in current viewport then the next view page grouped records are shown.
The collapsed/expanded state will persist only for local dataSource while scrolling.
Group with Page
topic..e-grid .e-row {
height: 2em;
}
selectRows
method is not supported in virtual scrolling.

Virtual Scrolling in Angular Data Grid

06 Aug 202624 minutes to read

The virtual scrolling feature in the Angular Data Grid seamlessly handles and displays large amounts of data without performance degradation. It improves the rendering process by loading only the visible rows in the grid viewport, rather than rendering the entire dataset at once. This powerful capability is essential when dealing with datasets that contain thousands of records.

To enable virtualization, inject the VirtualScrollService, which manages virtual scrolling behavior and optimized data rendering for performance.

Row virtualization

Row virtualization loads and renders rows only in the content viewport. It provides an effective alternative to traditional paging where data is loaded dynamically while scrolling vertically, rather than loading all the data at once. This approach significantly improves performance and reduces the initial load time when dealing with large datasets.

Row virtualization setup requires defining the enableVirtualization property to true and specifying content height using the height property in the grid configuration.

The Grid displays records based on the content area height. The pageSettings.pageSize property explicitly defines the visible number of records. The loaded data is cached and reused when needed in the future.

The following example enables row virtualization using the enableVirtualization property:

import { Component, OnInit } from '@angular/core';
import { EditService, EditSettingsModel, GridModule, PageService, PageSettingsModel, ToolbarItems, ToolbarService, VirtualScrollService } from '@syncfusion/ej2-angular-grids';

const names = ['TOM', 'Hawk', 'Jon', 'Chandler', 'Monica', 'Rachel', 'Phoebe', 'Gunther', 'Ross', 'Geller', 'Joey', 'Bing', 'Tribbiani',
 'Janice', 'Bong', 'Perk', 'Green', 'Ken', 'Adams'];
const hours = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
const designation = ['Manager', 'Engineer 1', 'Engineer 2', 'Developer', 'Tester'];
const status = ['Completed', 'Open', 'In Progress', 'Review', 'Testing']
const data = (count: any) => {
    const result = [];
    for (let i = 0; i < count; i++) {
        result.push({
          TaskID: i + 1,
          Engineer: names[Math.round(Math.random() * names.length)] || names[0],
          Designation: designation[Math.round(Math.random() * designation.length)] || designation[0],
          Estimation: hours[Math.round(Math.random() * hours.length)] || hours[0],
          Status: status[Math.round(Math.random() * status.length)] || status[0]
        });
    }
    return result;
};

@Component({
    imports: [GridModule],
    providers: [PageService, ToolbarService, EditService, VirtualScrollService],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-grid [dataSource]='data' height='290px' [enableVirtualization]=true [pageSettings]='options' [editSettings]='editSettings' [toolbar]='toolbar'>
                <e-columns>
                    <e-column field='TaskID' headerText='Task ID' textAlign='Right' width=100 isPrimaryKey='true' [validationRules]='rules'></e-column>
                    <e-column field='Engineer' width=100></e-column>
                    <e-column field='Designation' width=100 editType='dropdownedit' [validationRules]='rules'></e-column>
                    <e-column field='Estimation' textAlign='Right' width=100 editType='numericedit' [validationRules]='rules'></e-column>
                    <e-column field='Status' width=100 editType='dropdownedit'></e-column>
                </e-columns>
                </ejs-grid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public options?: PageSettingsModel;
    public rules: object = { required: true };
    public editSettings?: EditSettingsModel;
    public toolbar?: ToolbarItems[];
    ngOnInit(): void {
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
        this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
        this.data = data(5000);
        this.options = { pageSize: 50 };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations

  • Row virtual scrolling is incompatible with these features:
    1. Batch editing
    2. Detail template
    3. Row template
    4. Rowspan
    5. Autofill
    6. Hierarchy grid
  • Copy-paste and drag-and-drop are limited to rows currently visible in the viewport.
  • Cell-based selection is not supported.
  • Different row heights within a template column (when template heights vary by row) are not supported.
  • For remote data, group expand/collapse state is not persisted.
  • The total maximum number of records that can be virtualized is limited by browser scroll height capabilities.
  • Content height is calculated from row height and record count, so features altering row heights (like text wrapping) are not supported.
  • To support larger content or text-wrapped rows, set a uniform row height using CSS:

      .e-grid .e-row {
          height: 2em;
      }
  • Aggregates and group totals show values only for the current visible view. For totals across all data, see Group with paging.
  • Set a static height for the grid or its parent container; 100% height only works if both the component and its parent have explicit static heights.

Column virtualization

Column virtualization feature in the grid optimizes the rendering of columns by displaying only the columns that are currently within the viewport. It enables seamless horizontal scrolling to view additional columns. This powerful feature significantly improves performance and reduces the initial loading time when dealing with grids that have a large number of columns.

Column virtualization configuration requires setting the enableColumnVirtualization property of the grid to true. This configuration instructs the grid to render only the columns currently visible in the viewport.

The following example enables column virtualization using the enableColumnVirtualization property:

import { Component, OnInit } from '@angular/core';
import { EditService, EditSettingsModel, GridModule, PageService, PageSettingsModel, ToolbarItems, ToolbarService, VirtualScrollService } from '@syncfusion/ej2-angular-grids';

let virtualData: any = [];
let names: string[] = ['hardire', 'abramjo01', 'aubucch01', 'Hook', 'Rumpelstiltskin', 'Belle', 'Emma', 'Regina', 'Aurora', 'Elsa', 'Anna',
                      'Snow White', 'Prince Charming', 'Cora', 'Zelena', 'August', 'Mulan', 'Graham', 'Discord', 'Will', 'Robin Hood',
                      'Jiminy Cricket', 'Henry', 'Neal', 'Red', 'Aaran', 'Aaren', 'Aarez', 'Aarman', 'Aaron', 'Aaron-James', 'Aarron',
                       'Aaryan', 'Aaryn', 'Aayan', 'Aazaan', 'Abaan', 'Abbas', 'Abdallah', 'Abdalroof', 'Abdihakim', 'Abdirahman',
                     'Abdisalam', 'Abdul', 'Abdul-Aziz', 'Abdulbasir', 'Abdulkadir', 'Abdulkarem', 'Abdulkhader', 'Abdullah',
                     'Abdul-Majeed', 'Abdulmalik', 'Abdul-Rehman', 'Abdur', 'Abdurraheem', 'Abdur-Rahman', 'Abdur-Rehmaan', 'Abel',
                     'Abhinav', 'Abhisumant', 'Abid', 'Abir', 'Abraham', 'Abu', 'Abubakar', 'Ace', 'Adain', 'Adam', 'Adam-James',
                    'Addison', 'Addisson', 'Adegbola', 'Adegbolahan', 'Aden', 'Adenn', 'Adie', 'Adil', 'Aditya', 'Adnan', 'Adrian',
                    'Adrien', 'Aedan', 'Aedin', 'Aedyn', 'Aeron', 'Afonso', 'Ahmad', 'Ahmed', 'Ahmed-Aziz', 'Ahoua', 'Ahtasham',
                     'Aiadan', 'Aidan', 'Aiden', 'Aiden-Jack', 'Aiden-Vee'];

function dataSource(): void {
    for (let i = 0; i < 5000; i++) {
        virtualData.push({
            SNo: i + 1,
            FIELD1: names[Math.floor(Math.random() * names.length)],
            FIELD2: 1967 + (i % 10), FIELD3: Math.floor(Math.random() * 200),
            FIELD4: Math.floor(Math.random() * 100), FIELD5: Math.floor(Math.random() * 2000), FIELD6: Math.floor(Math.random() * 1000),
            FIELD7: Math.floor(Math.random() * 100), FIELD8: Math.floor(Math.random() * 10), FIELD9: Math.floor(Math.random() * 10),
            FIELD10: Math.floor(Math.random() * 100), FIELD11: Math.floor(Math.random() * 100), FIELD12: Math.floor(Math.random() * 1000),
            FIELD13: Math.floor(Math.random() * 10), FIELD14: Math.floor(Math.random() * 10), FIELD15: Math.floor(Math.random() * 1000),
            FIELD16: Math.floor(Math.random() * 200), FIELD17: Math.floor(Math.random() * 300), FIELD18: Math.floor(Math.random() * 400),
            FIELD19: Math.floor(Math.random() * 500), FIELD20: Math.floor(Math.random() * 700), FIELD21: Math.floor(Math.random() * 800),
            FIELD22: Math.floor(Math.random() * 1000), FIELD23: Math.floor(Math.random() * 2000), FIELD24: Math.floor(Math.random() * 150),
            FIELD25: Math.floor(Math.random() * 1000), FIELD26: Math.floor(Math.random() * 100), FIELD27: Math.floor(Math.random() * 400),
            FIELD28: Math.floor(Math.random() * 600), FIELD29: Math.floor(Math.random() * 500), FIELD30: Math.floor(Math.random() * 300),
        });
    }
}
dataSource();
@Component({
    imports: [GridModule],
    providers: [PageService, ToolbarService, EditService, VirtualScrollService],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-grid [dataSource]='data' height='290px' [enableColumnVirtualization]=true
                [pageSettings]='options' [editSettings]='editSettings' [toolbar]='toolbar'>
                <e-columns>
                    <e-column field='SNo' headerText='S.No' width=140 isPrimaryKey='true' [validationRules]='rules'></e-column>
                    <e-column field='FIELD1' headerText='Player Name' width=140 editType='dropdownedit' [validationRules]='rules'></e-column>
                    <e-column field='FIELD2' headerText='Year' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD3' headerText='Stint' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD4' headerText='TMID' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD5' headerText='LGID' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD6' headerText='GP' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD7' headerText='GS' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD8' headerText='Minutes' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD9' headerText='Points' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD10' headerText='oRebounds' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD11' headerText='dRebounds' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD12' headerText='Rebounds' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD13' headerText='Assists' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD14' headerText='Steals' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD15' headerText='Blocks' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD16' headerText='Turnovers' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD17' headerText='PF' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD18' headerText='fgAttempted' width=150 textAlign='Right'></e-column>
                    <e-column field='FIELD19' headerText='fgMade' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD20' headerText='ftAttempted' width=150 textAlign='Right'></e-column>
                    <e-column field='FIELD21' headerText='ftMade' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD22' headerText='ThreeAttempted' width=150 textAlign='Right'></e-column>
                    <e-column field='FIELD23' headerText='ThreeMade' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD24' headerText='PostGP' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD25' headerText='PostGS' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD26' headerText='PostMinutes' width=120 textAlign='Right'></e-column>
                    <e-column field='FIELD27' headerText='PostPoints' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD28' headerText='PostoRebounds' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD29' headerText='PostdRebounds' width=130 textAlign='Right'></e-column>
                    <e-column field='FIELD30' headerText='PostRebounds' width=130 textAlign='Right' editType='numericedit' [validationRules]='rules'></e-column>
                </e-columns>
                </ejs-grid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public options?: PageSettingsModel;
    public editSettings?: EditSettingsModel;
    public toolbar?: ToolbarItems[];
    public rules: object = { required: true };
    ngOnInit(): void {
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
        this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
        this.data = virtualData;
        this.options = { pageSize: 50 };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Column’s width is required for column virtualization. If column’s width is not defined then grid will consider its value as “200px”.

Limitations

  • Column width must be specified in pixels; percentage values are not accepted.
  • Column selection is retained only within the viewport. When new columns load, previously visible column selections are lost.
  • Fixed positioning applies only to viewport columns. When scrolling to new columns, fixed positioning is removed.
  • Cell selection is not supported for column virtual scrolling.
  • Ctrl + Home and Ctrl + End keyboard shortcuts are not supported with column virtual scrolling.

Compatible features (work within viewport):

  • Column resizing
  • Column reordering
  • Auto-fit
  • Print
  • Clipboard operations
  • Column menu with AutofitAll and Grouping options

Incompatible features:

  • Grouping
  • Column spanning
  • Batch editing
  • Stacked header
  • Row template
  • Detail template
  • Hierarchy grid
  • Autofill

Browser height limitation in virtual scrolling and solutions

Virtual scrolling enables loading millions of records efficiently by rendering rows on-demand while scrolling vertically. The grid lightens the browser’s load by minimizing DOM elements and rendering only visible elements in the viewport. Grid height is calculated using: Total records count × Row Height.

Browsers have a maximum allowable scrollable element height. When the grid’s content height exceeds this limit, vertical scrolling cannot access records beyond the browser’s max height. For example, with a row height of 30px and 1,000,000 records, the height could exceed 22,369,600 pixels—a hard limit in Chrome or Firefox. This restricts virtual scrolling beyond a certain record count in both grids and standard HTML tables.

Illustrations:

Browser height limitation in HTML table

Grid with browser height limitation

To address this browser limitation, consider the following approaches:

Solution 1: Using external buttons

Prevent the browser height limitation when scrolling through millions of records by loading data in segments.

In the following sample, the grid is rendered with a large number of records (nearly 2 million). The example scrolls “0.5” million records at a time. Once the last page of “0.5” million records is reached, the Load Next Set button appears at the bottom of the grid. Clicking that button displays the next set of “0.5” million records. A Load Previous Set button appears at the top to load the previous set of “0.5” million records.

The following steps demonstrate overcoming the limitation in the Syncfusion Grid component.

  1. Create a custom adaptor by extending UrlAdaptor and binding it to the grid DataSource property. In the processQuery method of the custom adaptor, we handled the Skip query based on the current page set to perform the data operation with whole records on the server.

         class CustomUrlAdaptor extends UrlAdaptor {
             processQuery(args) {
                 if (arguments[1].queries) {
                     for (const i = 0; i < arguments[1].queries.length; i++) {
                         if (arguments[1].queries[i].fn === 'onPage') {
                             // pageSet - defines the number of segments going to split the 2million records. In this example 0.5 million records are considered for each set so the pageSet is 1, 2, 3 and 4.
                             // maxRecordsPerPageSet - In this example the value is define as 0.5 million.
    
                             // gridPageSize - the pageSize defined in the Grid as pageSettings->pageSize property
    
                             // customize the pageIndex based on the current pageSet (It send the skip query including the previous pageSet ) so that the other operations performed for total 2millions records instead of 0.5 million alone.
                             arguments[1].queries[i].e.pageIndex = (((pageSet - 1) * maxRecordsPerPageSet) / gridPageSize) + arguments[1].queries[i].e.pageIndex;
                         }
                     }
                 }
                 let original = super.processQuery.apply(this, arguments);
                 return original;
             }
         }
         this.data = new DataManager({
             adaptor: new CustomUrlAdaptor(),
             url: "Home/UrlDatasource"
         });
  2. Render the grid by define the following features.

         <ejs-grid #grid [dataSource]='data' [enableVirtualization]='true' [pageSettings]='pageSettings' [height]='360' (beforeDataBound)='beforeDataBound($event)' >
             <e-columns>
                 <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=100></e-column>
                 ......
                 ......  
             </e-columns>
         </ejs-grid>
  3. In the beforeDataBound event, we set the args.count as “0.5” million to perform scrolling with “0.5” million records and all the data operations are performed with whole records which is handled using the custom adaptor. And also particular segment records count is less than “0.5” million means it will directly assigned the original segmented count instead of “0.5” million.

         beforeDataBound(args) {
             // storing the total records count which means 2 million records count
             totalRecords = args.count;
    
             // change the count with respect to maxRecordsPerPageSet (maxRecordsPerPageSet = 500000)
             args.count = args.count - ((pageSet - 1) * maxRecordsPerPageSet) > maxRecordsPerPageSet ?maxRecordsPerPageSet : args.count - ((pageSet - 1) * maxRecordsPerPageSet);
         }
  4. Render “Load Next Set” button and “Load Previous Set” button at bottom and top of the grid component.

         <button ejs-button cssClass="e-info prevbtn" (onClick)="prevBtnClick($event)" content="Load Previous Set..."></button>
    
         <ejs-grid #grid [dataSource]='data' [enableVirtualization]='true' [pageSettings]='pageSettings' [height]='360' (beforeDataBound)='beforeDataBound($event)' >
             <e-columns>
                 <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=100></e-column>
                 ......
                 ......  
             </e-columns>
         </ejs-grid>
    
         <button ejs-button cssClass="e-info nxtbtn" (onClick)="nxtBtnClick($event)" content="Load Next Set..."></button>
  5. While click on the “Load Next Set” / “Load Previous Set” button corresponding page data set is loaded to view remaining records of total 2 millions records after doing some simple calculation.

         // Triggered when clicking the Previous/ Next button.
         prevNxtBtnClick(args) {
             if (grid.element.querySelector('.e-content') && grid.element.querySelector('.e-content').getAttribute('aria-busy') === 'false') {
                 // Increase/decrease the pageSet based on the target element.
                 pageSet = args.target.classList.contains('prevbtn') ? --pageSet : ++pageSet;
                 this.rerenderGrid(); // Re-render the Grid component.
             }
         }

Prevent browser height limitation

Grid actions like filtering and sorting apply across the entire data set, not just the currently loaded segment.

Solution 2: Using RowHeight property

Reduce the row height using the rowHeight property to minimize total grid height before hitting the browser limit. If the limitation persists even after reduction, use segment navigation or paging.

Demonstration - scrollable records at 36px and 30px row heights:

Row Height

Solution 3: Using paging instead of virtual scrolling

Similar to virtual scrolling, the paging feature also loads the data in an on-demand concept. Pagination is also compatible with all the other features(Grouping, Editing, etc.) in grid. So, use the paging feature instead of virtual scrolling to view a large number of records in the grid without any kind of performance degradation or browser height limitation.

See also

How to load a million records in less than a second Grid